// evmhell.cpp : Defines the class behaviors for the application.
//
   
#include "stdafx.h"
#include "evmhell.h"

#include "MainFrm.h"
#include "evmhellDoc.h"
#include "evmhellView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




/////////////////////////////////////////////////////////////////////////////
// CEvmHellApp

BEGIN_MESSAGE_MAP(CEvmHellApp, CWinApp)
	//{{AFX_MSG_MAP(CEvmHellApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
  // Timer callback
  ON_THREAD_MESSAGE(WM_TIMER, OnTimerMessage)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEvmHellApp construction

CEvmHellApp::CEvmHellApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CEvmHellApp object

CEvmHellApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CEvmHellApp initialization

BOOL CEvmHellApp::InitInstance()
{
  //afxMemDF |= checkAlwaysMemDF;  // For checking memory allocation

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Don't set the registry key, instead use the .ini file

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

  // If a startup command was specified, execute it.
  CString startupCmd = GetProfileString("Startup", "Command");
  if (startupCmd != "") {
    int retval = system(startupCmd);
    if (retval == -1) {
      AfxMessageBox("Can't execute startup command \"" + startupCmd + "\"");
    }
  }


 
	// Register the application's document templates.  Document templates
	// serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CEvmHellDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CEvmHellTxView));   // Which of the 2 view types should I use???
	AddDocTemplate(pDocTemplate);
  pDocTemplate->SetContainerInfo(IDR_MAINFRAME); // Is this needed???


	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
  // This actually causes our document to be created.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

  // Turn on the timer.
  // This causes a WM_TIMER message to be repeatedly sent to the main thread.
  // It will be services by OnTimerMessage() below.

  // The timer timer should be less than half of the minimum Tx queue latency,
  // or otherwise the Tx queue will not be serviced often enough, and there
  // will be gaps between the transmitted characters...

#define TIMER_TIME  20     // In mS

  timerId = ::SetTimer(NULL, 0, TIMER_TIME, NULL);
  if (timerId == 0) {
    AfxMessageBox("Can't activate a system timer!!!  We're hosed!!!");
  }
   
	return TRUE;
}



int CEvmHellApp::ExitInstance()
{

  // Stop the timer

  if (timerId != 0)
    ::KillTimer(NULL, timerId);

  // If a shutdown command was specified, execute it.
  CString shutdownCmd = GetProfileString("Shutdown", "Command");
  if (shutdownCmd != "") {
    int retval = system(shutdownCmd);
    if (retval == -1) {
      AfxMessageBox("Can't execute shutdown command \"" + shutdownCmd + "\"");
    }
  }

  CWinApp::ExitInstance();


  return(0);
}




// This message handler gets called several times a second,
// and notifies the Doc that it ought to service the rx and tx data queues.
LONG CEvmHellApp::OnTimerMessage()
{
  // This works since we have only a single document.
  // However, make sure the document has not already been closed...
  
  CFrameWnd *pFrame = 
    (CFrameWnd*)AfxGetApp()->m_pMainWnd;
  
  if (pFrame) {
    CEvmHellDoc* doc = (CEvmHellDoc*)pFrame->GetActiveDocument();
    
    if (doc)
      doc->serviceDataQueues();
  }
  
  return 0;
}






/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	versionString;
	CString	buildString;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	versionString = _T("");
	buildString = _T("");
	//}}AFX_DATA_INIT

	versionString = CString("EvmHell version ") +
          CString(EVMHELL_VERSION_NUMBER);

  buildString = 
#ifdef _DEBUG
           CString("Debug ") +
#else
           CString("Release ") +
#endif
           CString("build compiled ") + CString(__DATE__);

}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_VERSION_STRING, versionString);
	DDX_Text(pDX, IDC_BUILD_STRING, buildString);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CEvmHellApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}



/////////////////////////////////////////////////////////////////////////////
// CEvmHellApp commands

