// evmhellView.cpp : implementation of the
// CEvmHellRxView and CEvmHellTxView classes
//

#include "stdafx.h"

#include <fstream>

#include "evmhell.h"
#include "evmhellDoc.h"
#include "evmhellView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEvmHellRxView

IMPLEMENT_DYNCREATE(CEvmHellRxView, CScrollView)

BEGIN_MESSAGE_MAP(CEvmHellRxView, CScrollView)
	//{{AFX_MSG_MAP(CEvmHellRxView)
	ON_WM_DROPFILES()
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEvmHellRxView construction/destruction

CEvmHellRxView::CEvmHellRxView()
{
	colDIBitmap = NULL;
  colBitmapBits = NULL;
}

CEvmHellRxView::~CEvmHellRxView()
{
  if (colDIBitmap)
    free(colDIBitmap);
  if (colBitmapBits)
    free(colBitmapBits);
}

BOOL CEvmHellRxView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

  //colBitmapDC.CreateCompatibleDC(NULL);  // Initialize our bitmap's DC
  //colBitmap.CreateCompatibleBitmap(&colBitmapDC, DATA_BIT_WIDTH, RX_CHAR_HEIGHT);
  //colBitmapDC.SelectObject(&colBitmap);

  //BITMAP bitmapInfo;
  //colBitmap.GetBitmap(&bitmapInfo);

 

  // Alocate our bitmap structures for drawing.
  // I think that the types of these structures are too wierd for "new" to work...
  colDIBitmap = (BITMAPINFO*)malloc(sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD));

  colDIBitmap->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
  colDIBitmap->bmiHeader.biWidth = DATA_BIT_WIDTH;
  colDIBitmap->bmiHeader.biHeight = RX_CHAR_HEIGHT;
  colDIBitmap->bmiHeader.biPlanes = 1;   // Must always be 1
  colDIBitmap->bmiHeader.biBitCount = 8;  // 8 BPP
  colDIBitmap->bmiHeader.biCompression = BI_RGB;  // No compression
  colDIBitmap->bmiHeader.biSizeImage = 0;
  colDIBitmap->bmiHeader.biClrUsed = 256;
  colDIBitmap->bmiHeader.biClrImportant = 0;  

  // Fill in its palette data
  for(int j=0; j< 256; j++) {
    colDIBitmap->bmiColors[j].rgbRed = j;
    colDIBitmap->bmiColors[j].rgbGreen = j;
    colDIBitmap->bmiColors[j].rgbBlue = j;
  }

  // The bits array must be properly aligned on longword boundaries,
  // and each scan line must be a multiple of a longword. E.g.
  // 3 bits = 3 bytes (for 256 colors), which becomes one 4-byte-long
  // longword.
  colBitmapBits = (char*)malloc(4*RX_CHAR_HEIGHT);
  for (int k=0; k<4*RX_CHAR_HEIGHT; k++) {
    colBitmapBits[k] = 0;
  }

 	return CScrollView::PreCreateWindow(cs);
}



/////////////////////////////////////////////////////////////////////////////
// CEvmHellRxView drawing



// Returns a CSize structure based on the number of strips in the
// document.  Used for setting scrollbars, etc.

CSize CEvmHellRxView::GetRxViewSize()
{
	CEvmHellDoc* pDoc = GetDocument();

  int nStrips = pDoc->nStrips;
  
  // The height is the space occupied by the strips, plus the top and
  // bottom, and left and right margins.
  return CSize(
    STRIP_WIDTH+LEFT_MARGIN+RIGHT_MARGIN,
    (STRIP_PITCH*nStrips)-STRIP_GAP+TOP_MARGIN+BOTTOM_MARGIN
  );
}


CRect CEvmHellRxView::getStripExtent(int stripNum)
{
  int left = LEFT_MARGIN;
  int top = TOP_MARGIN+(stripNum*STRIP_PITCH);

  return(CRect(left, top, left+STRIP_WIDTH, top+STRIP_HEIGHT));
             
}


// Internal proc to actually draw a pixel
// OBSOLETE!!!
void CEvmHellRxView::drawDataPixel(CDC *pDC, int x, int y, int val)
{
  
  int brightness = val;
  //brightness &= 0x00f0;   // Reduce to 16-level grayscale
  COLORREF pixelVal = RGB(brightness,brightness,brightness);
  int n;
  for(n=0; n<DATA_BIT_WIDTH; n++) {
    COLORREF actualPixel = pDC->SetPixel(x+n, y, pixelVal);
  }
}


void CEvmHellRxView::drawColumn(CDC* pDC, DataStrip *sp, int stripnum, int col, bool reverseVideo)
{
 
  int curStripY = (stripnum * STRIP_PITCH) + TOP_MARGIN;
  int curColX = (col * DATA_BIT_WIDTH) + LEFT_MARGIN;

  // Fill the bitmap with the correct bits.  Remember that a bitmap's Y
  // axis goes from bottom to top, but the display's goes the other way...
  char *bp = colBitmapBits;

  // rp is initialized to point to the first member of the column.
  unsigned char *rp = sp->pixels[col];
  for(int row=0; row<RX_CHAR_HEIGHT; row++) {
    int val = *rp++;
    if (reverseVideo)
      val = 255 - val;
    *bp++ = val;
    *bp++ = val;
    *bp++ = val;
    bp++;        // Remember that the bitmap bits are padded to a longword boundary
  }

  int retval = SetDIBitsToDevice(pDC->m_hDC, curColX, curStripY,
      DATA_BIT_WIDTH, RX_CHAR_HEIGHT, 0, 0, 0, RX_CHAR_HEIGHT, 
      colBitmapBits, colDIBitmap, DIB_RGB_COLORS);

  retval &= SetDIBitsToDevice(pDC->m_hDC, curColX+DATA_BIT_WIDTH,
      curStripY+RX_CHAR_HEIGHT,
      DATA_BIT_WIDTH, RX_CHAR_HEIGHT, 0, 0, 0, RX_CHAR_HEIGHT, 
      colBitmapBits, colDIBitmap, DIB_RGB_COLORS);

  if (retval == 0)
     int errcode = GetLastError();


#if 0
  for(row=0; row<RX_CHAR_HEIGHT; row++) {
    int val = sp->pixels[col][row];
    if (reverseVideo)
      val = 255 - val;

    drawDataPixel(pDC, col*DATA_BIT_WIDTH, curStripY+row, val);
    drawDataPixel(pDC, (col+1)*DATA_BIT_WIDTH, curStripY+RX_CHAR_HEIGHT+row, val);
  }
#endif

}



void CEvmHellRxView::OnDraw(CDC* pDC)
{
	CEvmHellDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

  CRect drawRect;
  int haveRect = pDC->GetClipBox(&drawRect);
  if (haveRect != ERROR && haveRect != NULLREGION) {
    int x = 0;
    x++;
  } else {
    drawRect.top = 1000000;
    drawRect.bottom = -1;
    drawRect.left = -1;
    drawRect.right = 1000000;
  }

  // Draw all the data represented in the Doc's DataStrips.

  bool reverseVid = pDoc->reverseVideo;

  int s;
  for(s=0; s<pDoc->nStrips; s++) {

    // See if the strip is at all visible, at least in the Y direction.
    CRect stripExtent = getStripExtent(s);

    if (stripExtent.top <= drawRect.bottom &&
       stripExtent.bottom >= drawRect.top) {
      
      DataStrip *sp = pDoc->strips[s];
      
      int col;

      // Don't draw unfilled part of last strip
      int nCols = (s==pDoc->nStrips-1) ? pDoc->curStripCol+1 : COLS_PER_STRIP;

      for(col=0; col<nCols; col++) {

        int xl = (col*DATA_BIT_WIDTH)+LEFT_MARGIN;
        int xh = xl+(2*DATA_BIT_WIDTH);
        
        if (xl <= drawRect.right && xh >= drawRect.left) {
          drawColumn(pDC, sp, s, col, reverseVid);
        }
      }
    }
  }

}


void CEvmHellRxView::ResyncScrollSizes()
{
//	CClientDC dc(NULL);
//	OnPrepareDC(&dc);
	CSize sizeDoc = GetRxViewSize();
//	dc.LPtoDP(&sizeDoc);
	SetScrollSizes(MM_TEXT, sizeDoc, pageSize, lineSize);
}


void CEvmHellRxView::ScrollToEnd()
{

  CSize docSize = GetRxViewSize();

  ResyncScrollSizes();

  CRect sizeRect;
  GetClientRect(&sizeRect);
  int windHeight = sizeRect.bottom - sizeRect.top;

  // If the data fits entirely within the window, top-justify it.
  // Otherwise, bottom-justify it.
  if (docSize.cy <= windHeight) {
    ScrollToPosition(CPoint(0,0));
  } else {
    ScrollToPosition(CPoint(0, docSize.cy - windHeight));
  }

}



// This is called by the document after a new strip is added.
// If the document was previously scrolled to the end (or almost to the end),
//  this will re-scroll it to the end.

void CEvmHellRxView::ScrollForNewStrip()
{
  CPoint scrollPos = GetScrollPosition();
  CRect sizeRect;
  GetClientRect(&sizeRect);
  int windHeight = sizeRect.bottom - sizeRect.top;

  int lastVisibleY = scrollPos.y + windHeight;

  CSize docSize = GetRxViewSize();
  int prevStripBottom = docSize.cy - BOTTOM_MARGIN - STRIP_PITCH;

  if (lastVisibleY >= prevStripBottom) {
    ScrollToEnd();
  }
}




// This is called by the document when newly-received data needs to be drawn

void CEvmHellRxView::DrawNewStripData(int strip, int col)
{
	CEvmHellDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

  CDC *pDC = GetDC();
  ASSERT_VALID(pDC);

#if 0
  // Sort of a hack, but it works.
  pDC->SetMapMode(m_nMapMode);
	pDC->SetViewportOrg(-GetDeviceScrollPosition());
#else
  // Is this better?
  CScrollView::OnPrepareDC(pDC, NULL);
#endif

  DataStrip *sp = pDoc->strips[strip];
  drawColumn(pDC, sp, strip, col, pDoc->reverseVideo);

  ReleaseDC(pDC);
}



/////////////////////////////////////////////////////////////////////////////
// CEvmHellRxView printing

BOOL CEvmHellRxView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CEvmHellRxView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CEvmHellRxView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CEvmHellRxView diagnostics

#ifdef _DEBUG
void CEvmHellRxView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CEvmHellRxView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CEvmHellDoc* CEvmHellRxView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEvmHellDoc)));
	return (CEvmHellDoc*)m_pDocument;
}
#endif //_DEBUG




void CEvmHellRxView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CScrollView::CalcWindowRect(lpClientRect, nAdjustType);
}


void CEvmHellRxView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{

  ResyncScrollSizes();

  
  // If we have a "hint", that means to draw only the most recently
  // received column.

  if (pHint) {
    DrawingHint *hint = (DrawingHint*)pHint;

    // Construct rectangle(s) that enclose the hinted-at column
    CRect colRect;
    colRect.top = hint->stripIndex * STRIP_PITCH;
    colRect.left = hint->stripCol * DATA_BIT_WIDTH;
    colRect.bottom = colRect.top + (STRIP_PITCH);
    colRect.right = colRect.left + DATA_BIT_WIDTH;
    InvalidateRect(&colRect, FALSE);
    // TODO: Do other rect

    
  } else {
    CScrollView::OnUpdate(pSender, lHint, pHint);  // Default implementation
  }

}


void CEvmHellRxView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	
  // Establish the amount that the arrow keys and the scrollbars will move data.
  pageSize = CSize(CHAR_WIDTH*DATA_BIT_WIDTH, 5*STRIP_PITCH);
  lineSize = CSize(CHAR_WIDTH*DATA_BIT_WIDTH, STRIP_PITCH/2);

  ResyncScrollSizes();

  DragAcceptFiles(TRUE);  // Accept File Manager filename drop messages
	
}



// This is called for File Manager filename dropping.
// It takes the file(s) and adds their data to the existing Rx data

void CEvmHellRxView::OnDropFiles(HDROP hDropInfo) 
{
	CEvmHellDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

  UINT nFiles = ::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);

  // Two possible ways to do this:  Either add the data to the existing
  // EvmHellDoc, or read it as a new document, just like the "Open" command.

#if 0
  for  (UINT iFile=0; iFile<nFiles; iFile++) {
    char fileName[_MAX_PATH+1];
    ::DragQueryFile(hDropInfo, iFile, fileName, _MAX_PATH);

    std::ifstream strm;

    strm.open(fileName, ios::binary);
    if (!strm.is_open()) {
      AfxMessageBox("Can't open dropped file " + CString(fileName));
    } else {
      while (!strm.eof()) {
        char dataChar;
        strm >> dataChar;
        pDoc->processRxChar(dataChar, FALSE);
      }
    }
  }

#else
  if (nFiles != 1) {
    AfxMessageBox("Hey! Only one file at a time!");
  } else {
    char fileName[_MAX_PATH+1];
    ::DragQueryFile(hDropInfo, 0, fileName, _MAX_PATH);
    AfxGetApp()->OpenDocumentFile(fileName);
  }

#endif

	
  ::DragFinish(hDropInfo);
}



void CEvmHellRxView::OnSize(UINT nType, int cx, int cy) 
{
  // Reset page size to be the closest multiple of the strip pitch.
  // Should I use LPtoDP() here, like in ResyncScrollSizes()???
  pageSize = CSize(CHAR_WIDTH*DATA_BIT_WIDTH, ((cy/STRIP_PITCH) * STRIP_PITCH));

  //ResyncScrollSizes();        // ensure that scroll info is up-to-date
	CScrollView::OnSize(nType, cx, cy);
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////



// CEvmHellTxView

IMPLEMENT_DYNCREATE(CEvmHellTxView, CRichEditView)

BEGIN_MESSAGE_MAP(CEvmHellTxView, CRichEditView)
	//{{AFX_MSG_MAP(CEvmHellTxView)
	ON_CONTROL_REFLECT(EN_PROTECTED, OnProtected)
	ON_CONTROL_REFLECT(EN_CHANGE, OnChange)
	ON_COMMAND(ID_OPERATE_LOOPFOREVER, OnOperateLoopforever)
	ON_UPDATE_COMMAND_UI(ID_OPERATE_LOOPFOREVER, OnUpdateOperateLoopforever)
	ON_COMMAND(ID_OPERATE_CLEARXMITTEDCHARS, OnOperateClearxmittedchars)
	ON_COMMAND(ID_EDIT_UNMARKXMITTEDCHARS, OnEditUnmarkxmittedchars)
	ON_COMMAND(ID_EDIT_XMITASFELDHELL, OnEditXmitasfeldhell)
	ON_UPDATE_COMMAND_UI(ID_EDIT_XMITASFELDHELL, OnUpdateEditXmitasfeldhell)
	ON_COMMAND(ID_EDIT_XMITASMORSE, OnEditXmitasmorse)
	ON_UPDATE_COMMAND_UI(ID_EDIT_XMITASMORSE, OnUpdateEditXmitasmorse)
	ON_WM_DROPFILES()
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE1, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE2, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE3, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE4, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE5, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE6, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE7, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE8, OnTransmitMessage)
 	ON_COMMAND(ID_EDIT_TRANSMIT_MESSAGE9, OnTransmitMessage)
	//}}AFX_MSG_MAP
	// Standard printing commands
	//ON_NOTIFY(EN_PROTECTED, 0, OnProtected)
  ON_COMMAND(ID_FILE_PRINT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRichEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEvmHellTxView construction/destruction

CEvmHellTxView::CEvmHellTxView()
{
	// TODO: add construction code here
  nextTxCharPos = 0;

  defaultCf.cbSize = sizeof(CHARFORMAT);
  defaultCf.dwMask = CFM_FACE | CFM_SIZE | CFM_PROTECTED | CFM_COLOR | CFM_BOLD;
  defaultCf.dwEffects = CFE_AUTOCOLOR;
  defaultCf.bPitchAndFamily = FIXED_PITCH | FF_MODERN;
  defaultCf.yHeight = 250;
  strcpy(defaultCf.szFaceName, "Courier New");

  xmittedCf.cbSize = sizeof(CHARFORMAT);
  xmittedCf.dwMask = CFM_COLOR | CFM_PROTECTED;
  xmittedCf.dwEffects = CFE_PROTECTED;
  xmittedCf.crTextColor = RGB(255,0,0);
  
  morseCf.cbSize = sizeof(CHARFORMAT);
  morseCf.dwMask = CFM_FACE | CFM_SIZE | CFM_PROTECTED | CFM_COLOR | CFM_BOLD;
  morseCf.dwEffects = CFE_AUTOCOLOR | CFE_BOLD;
  morseCf.bPitchAndFamily = FIXED_PITCH | FF_MODERN;
  morseCf.yHeight = 250;
  strcpy(morseCf.szFaceName, "Courier New");

  unxmittedCf.cbSize = sizeof(CHARFORMAT);
  unxmittedCf.dwMask = CFM_COLOR | CFM_PROTECTED;
  unxmittedCf.dwEffects = CFE_AUTOCOLOR;


}

CEvmHellTxView::~CEvmHellTxView()
{
}

BOOL CEvmHellTxView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRichEditView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CEvmHellTxView drawing

void CEvmHellTxView::OnDraw(CDC* pDC)
{
	CEvmHellDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CEvmHellTxView printing

BOOL CEvmHellTxView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
  return CRichEditView::OnPreparePrinting(pInfo);
	return DoPreparePrinting(pInfo);
}

void CEvmHellTxView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add extra initialization before printing
  CRichEditView::OnBeginPrinting(pDC, pInfo);
}

void CEvmHellTxView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add cleanup after printing
  CRichEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CEvmHellTxView diagnostics

#ifdef _DEBUG
void CEvmHellTxView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CEvmHellTxView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CEvmHellDoc* CEvmHellTxView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEvmHellDoc)));
	return (CEvmHellDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEvmHellTxView message handlers



void CEvmHellTxView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{

  CRichEditView::OnUpdate(pSender, lHint, pHint);

  // TODO: Add your specialized code here and/or call the base class

}

void CEvmHellTxView::OnInitialUpdate() 
{
	CRichEditView::OnInitialUpdate();
	
  // Does the bas class already do this?
  DragAcceptFiles(TRUE);   // Allow File Manager filename dropping.  

  // Set  the RichEdit controls event mask, so it will sent event
  // notifications.
    
  GetRichEditCtrl().SetDefaultCharFormat(defaultCf);
  GetRichEditCtrl().SetSelectionCharFormat(defaultCf);
 
  HWND w = GetRichEditCtrl().m_hWnd;

  // There is no need at the moment to get EM_CHANGE notifications...
//  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE | ENM_PROTECTED );
  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_PROTECTED );

  prevTextLen = GetTextLength();   // Presumably zero...
  loopForever = FALSE;
  morseInputMode = FALSE;
}


void CEvmHellTxView::OnProtected(NMHDR * pNotifyStruct, LRESULT * result) 
{
  // This does not work, for some reason.  However, the very similar
  // OnChange() does work.  The workaround is to grab the notification
  // message in the MainFrame window.

 	*result = 1;
}



void CEvmHellTxView::OnChange(NMHDR * pNotifyStruct, LRESULT * result) 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CRichEditView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.


  return;   // Is any of this necessary if we can't copy from protected text?
  
  // See if the user added or removed text.

  if (prevTextLen < GetTextLength()) {
    // Text was added.

    int amountAdded = GetTextLength() - prevTextLen;
    // If the user is pasting previously-transmitted text, we must fix the formatting

    // Save the current Selection position (actually the cursor position)
    CHARRANGE prevCR;
    GetRichEditCtrl().GetSel(prevCR);

    // Hide the selection
    GetRichEditCtrl().HideSelection(TRUE, FALSE);

    // Temporarily set it to the range of added chars
    CHARRANGE tmpCR;
    tmpCR.cpMax = prevCR.cpMin; 
    tmpCR.cpMin = tmpCR.cpMax - amountAdded;
    GetRichEditCtrl().SetSel(tmpCR);

    // TMP
    //CHARFORMAT tmpCf;
    //GetRichEditCtrl().GetSelectionCharFormat(tmpCf);

    // Give it the unxmitted format
    GetRichEditCtrl().SetSelectionCharFormat(unxmittedCf);
  
    // Restore the user's selection and un-hide it.
    GetRichEditCtrl().SetSel(prevCR);
    GetRichEditCtrl().HideSelection(FALSE, FALSE);
 
  } else if (prevTextLen > GetTextLength()) {
    // Text was removed
  }

  prevTextLen = GetTextLength();
}


void CEvmHellTxView::getNextXmitChar(int& txChar, bool& morse)
{
  
  // This finds the next character to transmit, and returns it.
  // If the buffer is empty, it returns NO_CHAR.
  // It updates the rich text display of the TxView.

  txChar = NO_CHAR;
  morse = FALSE;

  int textLength = GetRichEditCtrl().GetTextLength();
  
  //ASSERT(charPos <= textLength);
  
  // This could happen if the user deletes already-transmitted chars.
  if (nextTxCharPos > textLength)
    nextTxCharPos = textLength;

  // See if we have hit the end of the text in the View.
  if (nextTxCharPos == textLength) {

    if (loopForever && textLength > 0) {
      // Reset all the text as un-transmitted

      // Save the current Selection position (if set by the user)
      CHARRANGE prevCR;
      GetRichEditCtrl().GetSel(prevCR);
      
      // Hide the selection
      GetRichEditCtrl().HideSelection(TRUE, FALSE);
      
      // Temporarily set it to the entire text range.
      GetRichEditCtrl().SetSel(0, -1);
      
      // Give it the formats of un-transmitted text
      // We have to tell the control not to complain about
      // protected text being changed...
      HWND w = GetRichEditCtrl().m_hWnd;
      ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE );

      GetRichEditCtrl().SetSelectionCharFormat(unxmittedCf);
    
      ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE | ENM_PROTECTED );

       // Restore the user's selection and un-hide it.
      GetRichEditCtrl().SetSel(prevCR);
      GetRichEditCtrl().HideSelection(FALSE, FALSE);
      
      nextTxCharPos = 0;
    } else {
      txChar = NO_CHAR;
      return;  // No char available
    }
  }

  // Save the current Selection position (if set by the user)
  CHARRANGE prevCR;
  GetRichEditCtrl().GetSel(prevCR);

  // Hide the selection
  GetRichEditCtrl().HideSelection(TRUE, FALSE);

  // Temporarily set it to the next char to be transmitted.
  GetRichEditCtrl().SetSel(nextTxCharPos, nextTxCharPos+1);

  // Get its selection, to see if it is Morse or not
  CHARFORMAT tmpCf;
  GetRichEditCtrl().GetSelectionCharFormat(tmpCf);
  if (tmpCf.dwMask & CFM_BOLD && tmpCf.dwEffects & CFE_BOLD)
    morse = TRUE;

  // Give it the formats of already-transmitted text
  GetRichEditCtrl().SetSelectionCharFormat(xmittedCf);
  
  // Get the char
  char charBuf[80];
  GetRichEditCtrl().GetSelText(charBuf);

  // If the transmitted text range has reached the user's
  // selection, advance the selection to stay ahead of it.
  // This is because the user cannot even copy from
  // the protected transmitted text... 

  if (prevCR.cpMin < nextTxCharPos+1)
    prevCR.cpMin = nextTxCharPos+1;
  if (prevCR.cpMax < prevCR.cpMin)
    prevCR.cpMax = prevCR.cpMin;

  HWND w = GetRichEditCtrl().m_hWnd;
  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE );

  // Restore the user's selection and un-hide it.
  GetRichEditCtrl().SetSel(prevCR);
  GetRichEditCtrl().SetSelectionCharFormat(unxmittedCf);  // Important!
  
  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE | ENM_PROTECTED );

  GetRichEditCtrl().HideSelection(FALSE, FALSE);

  nextTxCharPos += 1;
  txChar = (unsigned char)charBuf[0];
}



void CEvmHellTxView::clearTxBuffer() 
{
  // Delete all un-transmitted text and reset the cursor, etc.

	// Hide the selection
  GetRichEditCtrl().HideSelection(TRUE, FALSE);

  // Temporarily set it to the range of untransmitted text.
  CHARRANGE tmpCR;
  tmpCR.cpMin = nextTxCharPos;
  tmpCR.cpMax = GetRichEditCtrl().GetTextLength() + 1;
  GetRichEditCtrl().SetSel(tmpCR);

  // Delete it.
  GetRichEditCtrl().Clear();
 
  GetRichEditCtrl().HideSelection(FALSE, FALSE);

  nextTxCharPos = GetRichEditCtrl().GetTextLength();

}


void CEvmHellTxView::OnOperateLoopforever() 
{
	loopForever = !loopForever;
}

void CEvmHellTxView::OnUpdateOperateLoopforever(CCmdUI* pCmdUI) 
{
  pCmdUI->SetCheck(loopForever);
}


void CEvmHellTxView::OnOperateClearxmittedchars() 
{
	// Delete all un-transmitted text and reset the cursor, etc.

	// Hide the selection
  GetRichEditCtrl().HideSelection(TRUE, FALSE);
  
  // Save the current Selection position (if set by the user)
  CHARRANGE prevCR;
  GetRichEditCtrl().GetSel(prevCR);
  
  // We have to tell the control not to complain about
  // protected text being changed...
  HWND w = GetRichEditCtrl().m_hWnd;
  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE );
  
    // Temporarily set it to the range of already-transmitted text.
  GetRichEditCtrl().SetSel(0, nextTxCharPos);
  
  // Delete it.
  GetRichEditCtrl().Clear();
  
  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE | ENM_PROTECTED );

  // Adjust the user's selection by the number of characters that were
  // removed.

  prevCR.cpMin -= nextTxCharPos;
  if (prevCR.cpMin < 0)
    prevCR.cpMin = 0;
  prevCR.cpMax -= nextTxCharPos;
  if (prevCR.cpMax < 0)
    prevCR.cpMax = 0;
    
  // Restore the user's selection and un-hide it.
  GetRichEditCtrl().SetSel(prevCR);
  GetRichEditCtrl().HideSelection(FALSE, FALSE);
  
  nextTxCharPos = 0;
  loopForever = FALSE;   // Nothing left to loop over...
	
}


void CEvmHellTxView::OnEditUnmarkxmittedchars() 
{
  // Un-mark all transmitted text, and reset nextTxCharPos

  if (nextTxCharPos == 0)
    return;  // Nothing to do

	// Hide the selection
  GetRichEditCtrl().HideSelection(TRUE, FALSE);
  
  // Save the current Selection position (if set by the user)
  CHARRANGE prevCR;
  GetRichEditCtrl().GetSel(prevCR);
  
  // We have to tell the control not to complain about
  // protected text being changed...
  HWND w = GetRichEditCtrl().m_hWnd;
  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE );
  
  // Temporarily set it to the range of already-transmitted text.
  GetRichEditCtrl().SetSel(0, nextTxCharPos);

  // Turn off its transmitted format attributes..
  GetRichEditCtrl().SetSelectionCharFormat(unxmittedCf);
  
  ::SendMessage(w, EM_SETEVENTMASK, 0, ENM_CHANGE | ENM_PROTECTED );

  // Restore the user's selection and un-hide it.
  GetRichEditCtrl().SetSel(prevCR);
  GetRichEditCtrl().HideSelection(FALSE, FALSE);
  
  nextTxCharPos = 0;
	
}

void CEvmHellTxView::OnEditXmitasfeldhell() 
{
  morseInputMode = FALSE;

  // For some strange reason, calling SetDefaultCharFormat does really
  // strange things, but SetSelectionCharFormat works perfectly...
  GetRichEditCtrl().SetSelectionCharFormat(defaultCf);
 
}

void CEvmHellTxView::OnUpdateEditXmitasfeldhell(CCmdUI* pCmdUI) 
{

  
  CHARFORMAT tmpCf;
  GetRichEditCtrl().GetSelectionCharFormat(tmpCf);
  if (tmpCf.dwMask & CFM_BOLD)
    pCmdUI->SetRadio(!(tmpCf.dwEffects & CFE_BOLD));
  else
    pCmdUI->SetRadio(!morseInputMode);
	
}

void CEvmHellTxView::OnEditXmitasmorse() 
{
  morseInputMode = TRUE;
  GetRichEditCtrl().SetSelectionCharFormat(morseCf);
  // TODO: Change current selction to Morse
}

void CEvmHellTxView::OnUpdateEditXmitasmorse(CCmdUI* pCmdUI) 
{
  

  CHARFORMAT tmpCf;
  GetRichEditCtrl().GetSelectionCharFormat(tmpCf);
  if (tmpCf.dwMask & CFM_BOLD)
    pCmdUI->SetRadio(tmpCf.dwEffects & CFE_BOLD);
  else
    pCmdUI->SetRadio(morseInputMode);
	
}



BOOL CEvmHellTxView::OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point) 
{
	// We do not want the underlying RichEditDoc to be involved...
	
	//return CRichEditView::OnDrop(pDataObject, dropEffect, point);
  return FALSE;
}

DROPEFFECT CEvmHellTxView::OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//return CRichEditView::OnDragEnter(pDataObject, dwKeyState, point);
  return DROPEFFECT_NONE;
}

void CEvmHellTxView::OnDragLeave() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//CRichEditView::OnDragLeave();
}

DROPEFFECT CEvmHellTxView::OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
	// TODO: Add your specialized code here and/or call the base class
	
//	return CRichEditView::OnDragOver(pDataObject, dwKeyState, point);
  return DROPEFFECT_NONE;
}


void CEvmHellTxView::OnDropFiles(HDROP hDropInfo) 
{
  // This is called for File Manager filename dropping, not OLE dropping!!!
	
	CRichEditView::OnDropFiles(hDropInfo);
}


void CEvmHellTxView::OnTransmitMessage() 
{
  // The IDs of the "transmit message" commands must be sequential...
  int commandID = LOWORD(GetCurrentMessage()->wParam);
	int messageNum = commandID - ID_EDIT_TRANSMIT_MESSAGE1;

  // Add the text of the selected message to the Rich Edit control
  // The data should be managed by this view, not the document...
  CString msg = GetDocument()->xmitMessageTexts[messageNum];

  if (msg != "") {
    GetRichEditCtrl().ReplaceSel(msg, TRUE);
  }

}



void CEvmHellRxView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{

  // Relay arrow keys, etc. the the base class of this view.
  switch(nChar) {

  case VK_NEXT:
    // Page Down
    OnVScroll(SB_PAGEDOWN, 0, NULL);
    break;
  case VK_PRIOR:
    // Page Up
    OnVScroll(SB_PAGEUP, 0, NULL);
    break;
  case VK_UP:
    // Up arrow
    OnVScroll(SB_LINEUP, 0, NULL);
    break;
  case VK_DOWN:
    // Up arrow
    OnVScroll(SB_LINEDOWN, 0, NULL);
    break;
  case VK_HOME:
    OnVScroll(SB_TOP, 0, NULL);
    break;
  case VK_END: 
    OnVScroll(SB_BOTTOM, 0, NULL);
    break;
  case VK_LEFT:
    OnHScroll(SB_LINELEFT, 0, NULL);
    break;
  case VK_RIGHT:
    OnHScroll(SB_LINERIGHT, 0, NULL);
    break;
  }

	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}
