// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"

#include "evmhell.h"
#include "evmhellDoc.h"
#include "evmhellView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
  ON_UPDATE_COMMAND_UI(ID_INDICATOR_TXRX_STATUS, OnUpdateTxRxStatus)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,  // status line indicator
  ID_INDICATOR_TXRX_STATUS,
  ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	BOOL bRet;
  
  // Create two static splitter windows, one for Tx and one for Rx.

  if (!m_wndSplitter.CreateStatic( this, 2, 1))
    return FALSE;

  bRet = m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CEvmHellTxView),
    CSize(300, 60), pContext);  // Show 3 lines or so
  if (!bRet)
    return FALSE;

  bRet = m_wndSplitter.CreateView(1, 0, RUNTIME_CLASS(CEvmHellRxView),
    CSize(300, 300), pContext);   // TODO: Set initial and min/max sizes
  if (!bRet)
    return FALSE;
  
  return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class

  NMHDR *pNmh = (LPNMHDR) lParam;

  // For some strange reason, the EN_PROTECTED messages from the Tx window
  // are not reflected to it (althogh EN_CHANGE messages are).  We are able to see
  // them here, though.
  if (pNmh->code == EN_PROTECTED) {
    *pResult = 1;  // Disallow changes to protected text.
    return 1;
  }
	
	return CFrameWnd::OnNotify(wParam, lParam, pResult);
}


void CMainFrame::OnUpdateTxRxStatus(CCmdUI *pCmdUI)
{
  pCmdUI->Enable();  // MS-specificed boilerplate

  CEvmHellDoc* curDoc = (CEvmHellDoc*)GetActiveDocument();
  if (curDoc)
    pCmdUI->SetText(((CEvmHellDoc*)GetActiveDocument())->getTxRxStatusStr());

}



